Merge branch 'master' of gnunet.org:gnunet
[oweals/gnunet.git] / src / gns / test_gns_dht_lookup.sh
1 #!/bin/bash
2 trap "gnunet-arm -e -c test_gns_lookup.conf" SIGINT
3 which timeout &> /dev/null && DO_TIMEOUT="timeout 30"
4
5 LOCATION=$(which gnunet-config)
6 if [ -z $LOCATION ]
7 then
8   LOCATION="gnunet-config"
9 fi
10 $LOCATION --version 1> /dev/null
11 if test $? != 0
12 then
13         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
14         exit 77
15 fi
16
17 TEST_IP="127.0.0.1"
18 MY_EGO="myego"
19 OTHER_EGO="delegatedego"
20
21
22 gnunet-arm -s -c test_gns_lookup.conf
23 gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
24 DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
25 gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
26 gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
27 gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
28 gnunet-arm -i gns -c test_gns_lookup.conf
29 sleep 0.5
30 gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP  -e never -c test_gns_lookup.conf
31 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
32 gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_lookup.conf
33 gnunet-arm -e -c test_gns_lookup.conf
34 rm -rf /tmp/test-gnunet-gns-peer-1/
35
36 if [ "$RES_IP" == "$TEST_IP" ]
37 then
38   exit 0
39 else
40   echo "Failed to resolve to proper IP, got $RES_IP."
41   exit 1
42 fi